class Which
  def initialize(@all_matches : Bool = false)
  end

  def find(programs : Array(String)) : Hash(String, Array(String))
    results = Hash(String, Array(String)).new

    programs.each do |program|
      results[program] = find_program(program)
    end

    results
  end

  private def find_program(program : String) : Array(String)
    matches = [] of String

    if program.includes?("/")
      matches << program if File.executable?(program)
    else
      ENV["PATH"].split(File::PATH_SEPARATOR).each do |path_element|
        path = path_element.not_empty? ? path_element : "."
        candidate = File.join(path, program)
        if File.executable?(candidate)
          matches << candidate
          break unless @all_matches
        end
      end
    end

    matches
  end
end

